searchNodes=[{"doc":"Module that manages websocket lifecycle and communication with client.Adapts the :cowboy_websocket behaviour.","ref":"Membrane.WebRTC.Server.Peer.html","title":"Membrane.WebRTC.Server.Peer","type":"behaviour"},{"doc":"Callback invoked when a peer process is started.Useful both for confirming the identity of the client, as well as setting up state and/or custom Cowboy WebSocket options, like timeout or maximal frame size.Options argument is value given under the :custom_options field in Membrane.WebRTC.Server.Options.Returning {:ok, websocket_options, state} will set up WebSocket options to the ones returned.Returning {:ok, state} will set up default WebSocket options with 15 minutes timeout. Returning {:error, details} will abort initialization of WebSocket and return a response with status 401.","ref":"Membrane.WebRTC.Server.Peer.html#c:on_init/3","title":"Membrane.WebRTC.Server.Peer.on_init/3","type":"callback"},{"doc":"Callback invoked after successful decoding received JSON message.Peer will proceed to send message returned by this callback to room, ergo returning {:ok, state} will cause ignoring message.Useful for modifying or ignoring messages.","ref":"Membrane.WebRTC.Server.Peer.html#c:on_receive/3","title":"Membrane.WebRTC.Server.Peer.on_receive/3","type":"callback"},{"doc":"Callback invoked when a peer is shutting down.Useful for any cleanup required.","ref":"Membrane.WebRTC.Server.Peer.html#c:on_terminate/2","title":"Membrane.WebRTC.Server.Peer.on_terminate/2","type":"callback"},{"doc":"Callback invoked to extract credentials and metadata from request.After successfully parsing the request, {:ok, credentials, metadata, room_name} should be returned. Credentials and metadata will be used to create Membrane.WebRTC.Server.Peer.AuthData which is passed to on_init/3 and Membrane.WebRTC.Server.Room.on_join/2.Returning {:error, details} will abort initialization of WebSocket and return a response with status 400.Peer will later try to join the room registered under room_name. If no such room can be found, peer will abort initialization of WebSocket and return a response with status 404.","ref":"Membrane.WebRTC.Server.Peer.html#c:parse_request/1","title":"Membrane.WebRTC.Server.Peer.parse_request/1","type":"callback"},{"doc":"Encodes message into JSON and sends it to client.","ref":"Membrane.WebRTC.Server.Peer.html#send_to_client/2","title":"Membrane.WebRTC.Server.Peer.send_to_client/2","type":"function"},{"doc":"Stops peer process.","ref":"Membrane.WebRTC.Server.Peer.html#stop/1","title":"Membrane.WebRTC.Server.Peer.stop/1","type":"function"},{"doc":"Defines custom state of a peer, passed as argument and returned by callbacks.","ref":"Membrane.WebRTC.Server.Peer.html#t:internal_state/0","title":"Membrane.WebRTC.Server.Peer.internal_state/0","type":"type"},{"doc":"Defines unique indetifier (UUIDv4) bound to peer.","ref":"Membrane.WebRTC.Server.Peer.html#t:peer_id/0","title":"Membrane.WebRTC.Server.Peer.peer_id/0","type":"type"},{"doc":"Structure representing data required to perform authentication during peer initialization and authorization when a peer is joining a room.Metadata and credentials are extracted via Membrane.WebRTC.Server.Peer.parse_request/1 and used in Membrane.WebRTC.Server.Peer.on_init/3 and Membrane.WebRTC.Server.Room.on_join/2. Fields:peer_id - A unique identifier created automatically during peer initialization.:credentials - Map containing information such as username and password.:metadata - Any additional metadata needed to perform authorization and authentication.","ref":"Membrane.WebRTC.Server.Peer.AuthData.html","title":"Membrane.WebRTC.Server.Peer.AuthData","type":"module"},{"doc":"","ref":"Membrane.WebRTC.Server.Peer.AuthData.html#t:t/0","title":"Membrane.WebRTC.Server.Peer.AuthData.t/0","type":"type"},{"doc":"Structure representing a state of peer passed to every (but Membrane.WebRTC.Server.Peer.parse_request/1) callback.Fields:room - Pid of room process.:peer_id - Unique identifier created automatically during peer initialization.","ref":"Membrane.WebRTC.Server.Peer.Context.html","title":"Membrane.WebRTC.Server.Peer.Context","type":"module"},{"doc":"","ref":"Membrane.WebRTC.Server.Peer.Context.html#t:t/0","title":"Membrane.WebRTC.Server.Peer.Context.t/0","type":"type"},{"doc":"Structure representing initial peer state. If Membrane.WebRTC.Server.Peer is used in Cowboy or Plug application, Elixir.Membrane.WebRTC.Server.Peer.Options should be used as InitialState in dispatch rule.Fields:module - Custom module implementing Membrane.WebRTC.Server.Peer callbacks.:custom_options - Options passed to Membrane.WebRTC.Server.Peer.on_init/3 callback.:registry - Registry in which Peer will lookup room. Membrane.WebRTC.Server.Registry by default.","ref":"Membrane.WebRTC.Server.Peer.Options.html","title":"Membrane.WebRTC.Server.Peer.Options","type":"module"},{"doc":"","ref":"Membrane.WebRTC.Server.Peer.Options.html#t:t/0","title":"Membrane.WebRTC.Server.Peer.Options.t/0","type":"type"},{"doc":"A behaviuor module for WebRTC room that manages peers and mediate in their communication.Rooms have to be created explicitly (preferably by start_supervised/2 function).","ref":"Membrane.WebRTC.Server.Room.html","title":"Membrane.WebRTC.Server.Room","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.WebRTC.Server.Room.html#child_spec/1","title":"Membrane.WebRTC.Server.Room.child_spec/1","type":"function"},{"doc":"Forwards the message to the addressees given under message.to key.Messages ment to be broadcasted should have message.to set to &quot;all&quot;. Broadcasted message will be forwarded to all peers, except for sender (given under message.from).","ref":"Membrane.WebRTC.Server.Room.html#forward_message/2","title":"Membrane.WebRTC.Server.Room.forward_message/2","type":"function"},{"doc":"Callback invoked before forwarding messages either peers.This mean this callback will be invoked every time message is forwarded or the room broadcasts messages by itself (e.g. when peer joins the room).Room will forward_message message returned by this callback, ergo returning {:ok, state} will cause ignoring message.","ref":"Membrane.WebRTC.Server.Room.html#c:on_forward/2","title":"Membrane.WebRTC.Server.Room.on_forward/2","type":"callback"},{"doc":"Callback invoked when a room is created.","ref":"Membrane.WebRTC.Server.Room.html#c:on_init/1","title":"Membrane.WebRTC.Server.Room.on_init/1","type":"callback"},{"doc":"Callback invoked when a peer is about to join the room.Useful for authorizing or performing other checks (e.g. controlling number of peers in room).Returning {:error, error} will cause peer sending Membrane.WebRTC.Server.Message.error_message/0 to the client and closing WebSocket.","ref":"Membrane.WebRTC.Server.Room.html#c:on_join/2","title":"Membrane.WebRTC.Server.Room.on_join/2","type":"callback"},{"doc":"Callback invoked when a peer is leaving the room.","ref":"Membrane.WebRTC.Server.Room.html#c:on_leave/2","title":"Membrane.WebRTC.Server.Room.on_leave/2","type":"callback"},{"doc":"Callback invoked when the room is shutting down.Useful for any cleanup required.","ref":"Membrane.WebRTC.Server.Room.html#c:on_terminate/1","title":"Membrane.WebRTC.Server.Room.on_terminate/1","type":"callback"},{"doc":"Starts a room based on the options.module, registers it in options.registry (under the options.name) and links it to the current process.options.custom_options are passed to module's on_init/1 callback.","ref":"Membrane.WebRTC.Server.Room.html#start_link/1","title":"Membrane.WebRTC.Server.Room.start_link/1","type":"function"},{"doc":"Creates a room under the default room supervisor.Calls start_link/1 underneath.","ref":"Membrane.WebRTC.Server.Room.html#start_supervised/1","title":"Membrane.WebRTC.Server.Room.start_supervised/1","type":"function"},{"doc":"Stops room process.","ref":"Membrane.WebRTC.Server.Room.html#stop/1","title":"Membrane.WebRTC.Server.Room.stop/1","type":"function"},{"doc":"Defines a custom state of the room, passed as argument and returned by callbacks.","ref":"Membrane.WebRTC.Server.Room.html#t:internal_state/0","title":"Membrane.WebRTC.Server.Room.internal_state/0","type":"type"},{"doc":"Structure representing options that can be passed to Membrane.WebRTC.Server.Room.start_supervised/1 and Membrane.WebRTC.Server.Room.start_link/1.Fieldscustom_options - Options passed to Membrane.WebRTC.Server.Room.on_init/1 callback.name - Name under which room will be registered.module - Custom module implementing Membrane.WebRTC.Server.Room behaviour. registry - Registry in which room will be registered. Membrane.WebRTC.Server.Registry by default.","ref":"Membrane.WebRTC.Server.Room.Options.html","title":"Membrane.WebRTC.Server.Room.Options","type":"module"},{"doc":"","ref":"Membrane.WebRTC.Server.Room.Options.html#t:custom_options/0","title":"Membrane.WebRTC.Server.Room.Options.custom_options/0","type":"type"},{"doc":"","ref":"Membrane.WebRTC.Server.Room.Options.html#t:t/0","title":"Membrane.WebRTC.Server.Room.Options.t/0","type":"type"},{"doc":"Struct defining messages exchanged between peers and rooms.Fields:data - Main part of the message. Value under that field MUST BE encodable by Jason.Encoder.:event - Topic of the message.:from - Peer ID of a sender.:to - Either list of peer IDs of addressees or &quot;all&quot;. If this field is set to &quot;all&quot;, the message will be broadcasted: all peers in the room (except for the peer specified under from field) will receive this message. Messages in Server APIMessages used by Membrane.WebRTC.Server.Room and Membrane.WebRTC.Server.Peer modules:authenticated_message/0error_message/0joined_message/0left_message/0Note that these are NOT the only types of Messages, that can be used in applications. Custom types can be defined with t/1.","ref":"Membrane.WebRTC.Server.Message.html","title":"Membrane.WebRTC.Server.Message","type":"module"},{"doc":"Sent to client after peer successfully initialize and join the room. :event is set to &quot;authenticated&quot;.Data fields:peer_id - Identifier of the peer, that has joined the room.","ref":"Membrane.WebRTC.Server.Message.html#t:authenticated_message/0","title":"Membrane.WebRTC.Server.Message.authenticated_message/0","type":"type"},{"doc":"Error message. :event is set to &quot;error&quot;.Data fields:description- Topic of error message.:details - Details of error. Descriptions used in server API&quot;Invalid message&quot; Sent to client after JSON decoding error.&quot;Could not join room&quot; Sent to client after Membrane.WebRTC.Server.Room.on_join/2 return {:error, error}.&quot;Room closed&quot; Send to client after the room's process shut down.","ref":"Membrane.WebRTC.Server.Message.html#t:error_message/0","title":"Membrane.WebRTC.Server.Message.error_message/0","type":"type"},{"doc":"Broadcasted by a room when a peer joins the room. :event is set to &quot;joined&quot;.:to is set to &quot;all&quot;.Data fields:peer_id - Identifier of the peer, that has joined the room.","ref":"Membrane.WebRTC.Server.Message.html#t:joined_message/0","title":"Membrane.WebRTC.Server.Message.joined_message/0","type":"type"},{"doc":"Broadcasted by a room when a peer leaves the room. :event is set to &quot;left&quot;.Data fields::peer_id - Identifier of the peer, that has left the room.","ref":"Membrane.WebRTC.Server.Message.html#t:left_message/0","title":"Membrane.WebRTC.Server.Message.left_message/0","type":"type"},{"doc":"","ref":"Membrane.WebRTC.Server.Message.html#t:t/0","title":"Membrane.WebRTC.Server.Message.t/0","type":"type"},{"doc":"Type prepared for defining custom Membrane.WebRTC.Server.Message.d MUST BE encodable by Jason.Encoder.","ref":"Membrane.WebRTC.Server.Message.html#t:t/1","title":"Membrane.WebRTC.Server.Message.t/1","type":"type"},{"doc":"WebRTC Signaling Server Elixir signaling server for WebRTC based on Cowboy WebSocket. Consists of tw main parts: Peer and Room.It's a part of the Membrane Framework.","ref":"readme.html","title":"WebRTC Signaling Server","type":"extras"},{"doc":"Example applications based on Plug can be found here.","ref":"readme.html#example-applications","title":"WebRTC Signaling Server - Example applications","type":"extras"},{"doc":"Copyright 2019, Software MansionLicensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"WebRTC Signaling Server - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Guide","ref":"guide.html","title":"Guide","type":"extras"},{"doc":"For each browser client, there is a process on the server side, which is called peer. Peers, grouped in rooms, are responsible for communication with their clients. Since this communication is based on WebSocket, the peer process starts when a client opens a WebSocket connection (probably with new WebSocket(URL)) and thus, upgrade request is send.After receiving a request, Membrane.WebRTC.Server.Peer.peer_id/0 will be automatically generated. Then a peer should parse the request with Membrane.WebRTC.Server.Peer.parse_request/1 callback. Credentials and metadata returned from it will be used to create Membrane.WebRTC.Server.Peer.AuthData and room's name will be used to get a room's PID from the registry (specified in Membrane.WebRTC.Options. Then, the state is initialized in Membrane.WebRTC.Server.Peer.on_init/3 and authentication is performed with Membrane.WebRTC.Server.Peer.AuthData extracted from the request. Finally, WebSocket is initialized.After successful initialization, the peer will try to join the room with the name returned from the Membrane.WebRTC.Server.Peer.parse_request/1. Authorization (with the same Membrane.WebRTC.Server.Peer.AuthData) or other checks can be performed in Membrane.WebRTC.Server.Room.on_join/2 callback. Room automatically broadcast Membrane.WebRTC.Server.Message.joined_message/0 to notify other peers about the new one. After that, the peer will send Membrane.WebRTC.Server.Message.authenticated_message/0 to the client to inform about successful initialization.","ref":"guide.html#peer-initialization","title":"Guide - Peer initialization","type":"extras"},{"doc":"The client communicates with a peer by exchanging JSON messages. These messages should have the same fields as the Membrane.WebRTC.Server.Message, which is used in internal communication. Other fields of JSON will be lost in decoding.Every JSON received from the client will be decoded into the Membrane.WebRTC.Server.Message struct. The peer will set :from field with own peer_id. Then it will send a message to the room, where it will be forwarded to the addressees. The addressees and sender are specified in to and from message fields by peer_ids.The message can be modified or ignored by both peer and room using Membrane.WebRTC.Server.Peer.on_receive/3 and Membrane.WebRTC.Server.Room.on_forward/2 callbacks. The addressee peer, after receiving the message will encode it back to JSON and send it to its client.Creating example applicationThis guide focus on writing simple WebRTC application based on Plug.Complete source code can be found here.","ref":"guide.html#signalling","title":"Guide - Signalling","type":"extras"},{"doc":"Create a new mix project with$ mix new server --module ServerTo create a server, we have to add Membrane WebRTC Server to dependencies. Add this line to the deps in mix.exs.{:membrane_webrtc_server, &quot;~&gt; 0.1&quot;}We will also use Plug (i.a. to set up routing) and Jason (to parse credentials received from the app:{:jason, &quot;~&gt; 1.1&quot;}, {:plug, &quot;~&gt; 1.7&quot;}, {:plug_cowboy, &quot;~&gt; 2.0&quot;}","ref":"guide.html#setting-up-a-project","title":"Guide - Setting up a project","type":"extras"},{"doc":"Inside lib/server folder create a new module which uses Membrane.WebRTC.Server.Peer.defmodule Server.Peer use Membrane.WebRTC.Server.Peer ...","ref":"guide.html#creating-a-peer-module","title":"Guide - Creating a peer module","type":"extras"},{"doc":"Before initialization of peer, an authentication request is parsed in parse_request. This function receives the request and should return a tuple containing :ok atom, credentials, metadata and name of the room peer wants to join.@impl true def parse_request(request) do ... {:ok, credentials, metadata, room_name} endLet's assume that JS client will specify room in URL binding. We can get the name with the following function:defp get_room_name(request) do room_name = :cowboy_req.binding(:room, request) if room_name == :undefined do {:error, :no_room_name_bound_in_url} else {:ok, room_name} end endEasy way to send credentials with WebSocket upgrade request is to include them in a cookie. After retrieving them, we should decode them with Jason.decode.defp get_credentials(request) do case :cowboy_req.parse_cookies(request) |&gt; List.keyfind(&quot;credentials&quot;, 0) do {&quot;credentials&quot;, json} -&gt; Jason.decode(json) _ -&gt; {:error, :no_credentials_passed} endNow we can finish implementing parse_request. We have our room name, credentials and we don't need metadata for this request, so we will return nil instead of it. The finished function should look like something like this:@impl true def parse_request(request) do with {:ok, room_name} &lt;- get_room_name(request), {:ok, credentials} &lt;- get_credentials(request) do {:ok, credentials, nil, room_name} end endPlease notice that storing non-hashed credentials in cookie is unsafe (since they are available as plain text). Example of more sophisticated authentication based on Guardian can be found here.","ref":"guide.html#implementing-parse_request-callback","title":"Guide - Implementing parse_request callback","type":"extras"},{"doc":"Authentication happens before WebSocket initialization. We can perform it in on_init callback, for example: @impl true def on_init(_context, auth_data, _options) do username = Map.get(auth_data.credentials, &quot;username&quot;) password = Map.get(auth_data.credentials, &quot;password&quot;) if username == &quot;USERNAME&quot; and password == &quot;PASSWORD&quot; do {:ok, %{}} else {:error, :wrong_credentials} end endThe return value (in case of successful authentication) contains an empty map, which is a new state for the peer.","ref":"guide.html#authentication","title":"Guide - Authentication","type":"extras"},{"doc":"Since mesh WebRTC can't scale to a large number of participants, we will create Room which will block not let more than 2 peers in.Inside lib/server/ folder create a new module which uses Membrane.WebRTC.Server.Room.defmodule Example.Simple.Room do use Membrane.WebRTC.Server.RoomStarting room process will get the maximal number of peers from initial options (value under :custom_options field in Membrane.WebRTC.Server.Room.Options). We can specify that behaviour in handle_init implementation.@impl true def on_init(options) do {:ok, %{number_of_peers: 0, max_peers: options.max_peers}} endSo, as you can see, options will be map with field :max_peers.The return value contains a map (new state of our room) with the current number of peers and the maximal number of peers. Starting room is empty, so :number_of_peers equals 0.Every time peer will join the room we must check, if we surpass allowed number. If not, the room must increment it. We'll specify that behaviour in on_join callback.@impl true def on_join(_auth_data, state) do current_number = state.number_of_peers if current_number &lt; state.max_peers do {:ok, Map.put(state, :number_of_peers, current_number + 1)} else {{:error, :room_is_full}, state} end endWhen this function return error, an error message will be sent to the client.Of course, we also have to decrement the number of peers if some peer leaves.@impl true def on_leave(_peer_id, state) do {:ok, Map.put(state, :number_of_peers, state.number_of_peers - 1)} endTo sum up, the whole file should look like this:defmodule Server.Room do use Membrane.WebRTC.Server.Room @impl true def on_init(options) do {:ok, %{number_of_peers: 0, max_peers: options.max_peers}} end @impl true def on_join(_auth_data, state) do current_number = state.number_of_peers if current_number &lt; state.max_peers do {:ok, Map.put(state, :number_of_peers, current_number + 1)} else {{:error, :room_is_full}, state} end end @impl true def on_leave(_peer_id, state) do {:ok, Map.put(state, :number_of_peers, state.number_of_peers - 1)} end end","ref":"guide.html#implementing-room","title":"Guide - Implementing room","type":"extras"},{"doc":"As mentioned before, this application uses Plug to set up routing. Let's configure our router:defmodule Example.Simple.Router do use Plug.Router plug(Plug.Static, at: &quot;/&quot;, from: :example_simple ) plug(:match) plug(:dispatch) get &quot;/:room&quot; do send_file(conn, 200, &quot;priv/static/html/index.html&quot;) end match _ do send_resp(conn, 404, &quot;404&quot;) end endAs you can see, the URL will specify room for the client.","ref":"guide.html#configuring-router","title":"Guide - Configuring router","type":"extras"},{"doc":"Since the application uses HTTPS, certificate and key are needed to run it. You generate them with$ openssl req -newkey rsa:2048 -nodes -keyout priv/certs/key.pem -x509 -days 365 -out priv/certs/certificate.pemNote that this certificate is not validated and thus may cause warnings in the browser.","ref":"guide.html#generating-key-and-certificate","title":"Guide - Generating key and certificate","type":"extras"},{"doc":"Now, with ready Room, Peer and Router, we can configure how our application is started. Inside lib/server.ex create module Server, which uses Application.defmodule Server do use Application alias Membrane.WebRTC.Server.Peer alias Membrane.WebRTC.Server.Room ...First of all, we have to configure our dispatch function. It will specify routes rules. Let's assume that a WebSocket upgrade request will be given at /socket/[:room]. Our Router will take care of every other request.defp dispatch do peer_options = %Peer.Options{module: Server.Peer} [ {:_, [ {&quot;/socket/[:room]/&quot;, Membrane.WebRTC.Server.Peer, peer_options}, {:_, Plug.Cowboy.Handler, {Example.Simple.Router, []}} ]} ] endAs you can see, we also specify options for starting peer process.We have to implement a start function, in which we will start other processes.@impl true def start(_type, _args) do options = [strategy: :one_for_one, name: Server] children = [ ... ] Supervisor.start_link(children, options) endInside the children list, we will specify two workers: Plug.Cowboy and Server.Room. children = [ Plug.Cowboy.child_spec( scheme: Application.fetch_env!(:server, :scheme), plug: Example.Simple.Router, options: [ dispatch: dispatch(), port: 8443, ip: {0, 0, 0, 0}, password: &quot;PASSWORD&quot;, otp_app: :example_simple, keyfile: &quot;priv/certs/key.pem&quot;, certfile: &quot;priv/certs/certificate.pem&quot; ] ), Supervisor.child_spec( {Room, %Room.Options{ name: &quot;room&quot;, module: Server.Room, custom_options: %{max_peers: 2} }}, id: :room ) ]If you want to start room after application is started (i.e. every time peer wants to join non-existing room), you can use Room.start_supervised function.We can also add other rooms, with different names and/or maximal numbers of peers.... Supervisor.child_spec( {Room, %Room.Options{ name: &quot;other&quot;, module: Server.Room, custom_options: %{max_peers: 4} }}, id: :other_room ) ...","ref":"guide.html#dispatching-and-starting-the-application","title":"Guide - Dispatching and starting the application","type":"extras"}]